const severeWarningEvents = ["Severe Thunderstorm Warning","Destructive Severe Thunderstorm Warning","Considerable Destructive Severe Thunderstorm Warning"]
const tornadoWarningEvents = ["Tornado Warning","Radar Indicated Tornado Warning","Confirmed Tornado Warning","Tornado Emergency"]

let alerts = msg.payload

// Filter for Severe Thunderstorm Warnings

let ts = alerts.filter(function(alert) {
    if (alert.raw.properties &&
    severeWarningEvents.includes(alert.raw.properties.event)) {
        return true
    }
})

// Filter for Severe Thunderstorm Warnings with tornado detection
// that have a tornado possible parameter

let tstp = alerts.filter(function(alert) {
    if (alert.raw.properties &&
    severeWarningEvents.includes(alert.raw.properties.event) &&
    alert.raw.properties.parameters &&
    alert.raw.properties.parameters.tornadoDetection &&
    alert.raw.properties.parameters.tornadoDetection.length > 0) {
        let tornadoPossible = alert.raw.properties.parameters.tornadoDetection[0]
        return tornadoPossible === "POSSIBLE"
    }
})

// Filter for considerable destructive severe thunderstorm warnings

let cdst = alerts.filter(function(alert) {
    if (alert.raw.properties &&
    alert.raw.properties.event === "Considerable Destructive Severe Thunderstorm Warning") {
        return true
    }
})

// Filter for Tornado Warnings

let tornado = alerts.filter(function(alert) {
    if (alert.raw.properties &&
    tornadoWarningEvents.includes(alert.raw.properties.event)) {
        return true
    }
})

let confirmed_tornado = alerts.filter(function(alert) {
    if (alert.raw.properties &&
    alert.raw.properties.event === "Confirmed Tornado Warning") {
        return true
    }
})

// If there are any alerts, return them

let tstormMsg = {
    "payload": {
        "alerts": ts,
        "count": ts.length,
        "tornado_possible": tstp.length,
        "considerable_destructive": cdst.length
    }
}

let tornadoWarnMsg = {
    "payload": {
        "alerts": tornado,
        "count": tornado.length,
        "confirmed": confirmed_tornado.length
    }
}

node.send([tstormMsg,tornadoWarnMsg])
node.status({fill:'green',shape:'dot',text:'Alerts Updated'})